//--------------------------------------------------------------
// File     : main.c
// Datum    : 31.12.2015
// Version  : 1.0
// Autor    : UB
// EMail    : mc-4u(@)t-online.de
// Web      : www.mikrocontroller-4u.de
// CPU      : STM32F4
// IDE      : CooCox CoIDE 1.7.8
// GCC      : 4.9 2015q2
// Module   : CMSIS_BOOT, M4_CMSIS_CORE
// Funktion : DCF77-Demo
// Hinweis  : Diese zwei Files muessen auf 8MHz stehen
//              "cmsis_boot/stm32f4xx.h"
//              "cmsis_boot/system_stm32f4xx.c"
//--------------------------------------------------------------

#include "main.h"
#include "stm32_ub_dcf77.h"
#include "stm32_ub_uart.h"
#include <stdio.h>

int main(void)
{
  DCF77_Status_t status,old_status=99;
  uint8_t old_sek=99;
  char buf[30];

  SystemInit(); // Quarz Einstellungen aktivieren

  UB_Uart_Init();

  // init vom DCF77-Modul
  UB_DCF77_Init();

  UB_Uart_SendString(COM2,"DCF77-Start",CRLF);

  while(1)
  {
    status=UB_DCF77_ReadTime();
    if(status!=old_status) {
      old_status=status;
      if(status==DCF77_NO_SIGNAL) UB_Uart_SendString(COM2,"no signal",CRLF);
      if(status==DCF77_READING) UB_Uart_SendString(COM2,"reading...",CRLF);
      if(status==DCF77_TIME_ERROR) UB_Uart_SendString(COM2,"error",CRLF);
    }
    if(status==DCF77_TIME_OK) {
      if(DCF77_TIME.sek!=old_sek) {
        old_sek=DCF77_TIME.sek;
        sprintf(buf,"h=%d, m=%d, s=%d",DCF77_TIME.std,DCF77_TIME.min,DCF77_TIME.sek);
        UB_Uart_SendString(COM2,buf,CRLF);
        sprintf(buf,"d=%d, m=%d, j=%d",DCF77_TIME.tag,DCF77_TIME.monat,DCF77_TIME.jahr);
        UB_Uart_SendString(COM2,buf,CRLF);
      }
    }
  }
}

